aboutsummaryrefslogtreecommitdiff
path: root/X/xinitrc.d/browser.sh
diff options
context:
space:
mode:
Diffstat (limited to 'X/xinitrc.d/browser.sh')
-rw-r--r--X/xinitrc.d/browser.sh26
1 files changed, 23 insertions, 3 deletions
diff --git a/X/xinitrc.d/browser.sh b/X/xinitrc.d/browser.sh
index cdb9b8c0..0153fba9 100644
--- a/X/xinitrc.d/browser.sh
+++ b/X/xinitrc.d/browser.sh
@@ -1,4 +1,24 @@
-# Browser within X is Firefox
-command -v firefox >/dev/null 2>&1 || return
-BROWSER=firefox
+# Choose a GUI browser with some rough heuristics
+
+# If Firefox is available, start by assuming that
+if command -v firefox >/dev/null 2>&1 ; then
+ BROWSER=firefox
+fi
+
+# Consider a switch to Dillo...
+if (
+ # No output, please
+ exec >/dev/null 2>&1
+ # Don't switch if it's not there
+ command -v dillo || exit
+ # Switch if Firefox isn't there
+ command -v firefox || exit 0
+ # Switch if procfs says we have less than 2GB of RAM
+ awk '$1=="MemTotal:"&&$2<2^20{m++}END{exit!m}' < /proc/meminfo
+) ; then
+ BROWSER=dillo
+fi
+
+# Export our choice of browser, if it isn't empty
+[ -n "$BROWSER" ] || return
export BROWSER